package com.bergerkiller.bukkit.nolagg;

import java.io.File;
import java.lang.reflect.Field;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.World.Environment;
import org.bukkit.craftbukkit.CraftServer;

import net.minecraft.server.IChunkLoader;
import net.minecraft.server.IChunkProvider;
import net.minecraft.server.IDataManager;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.PlayerFileData;
import net.minecraft.server.WorldData;
import net.minecraft.server.WorldProvider;
import net.minecraft.server.WorldServer;
import net.minecraft.server.WorldSettings;

@SuppressWarnings("rawtypes")
public class DummyWorld extends WorldServer {

	private static String getDummyName() {
		String worldname = "dummy";
		while (Bukkit.getServer().getWorld(worldname) != null) {
			worldname += "y";
		}
		return worldname;
	}
	private static IDataManager getDummyDataManager() {
		return new IDataManager() {
			public IChunkLoader a(WorldProvider arg0) {return null;}
			public void a(WorldData arg0) {}
			public void a(WorldData arg0, List arg1) {}
			public void b() {}
			public File b(String arg0) {return null;}
			public WorldData c() {return null;}
			public PlayerFileData d() {return null;}
			public void e() {}
        	public UUID getUUID() {return null;}
        };
	}
	private static MinecraftServer getMC() {
		return ((CraftServer) Bukkit.getServer()).getServer();
	}
	private static WorldSettings getDummySettings() {
		return new WorldSettings(0, 0, true, false);
	}
	
	public DummyWorld() throws Exception {
		this(getDummyName());
	}
	public DummyWorld(String worldname) throws Exception {
		super(getMC(), getDummyDataManager(), worldname, 0, getDummySettings(), Environment.NORMAL, null);
		//dereference this dummy world again...
		Field worlds = CraftServer.class.getDeclaredField("worlds");
		worlds.setAccessible(true);
		((Map) worlds.get(getServer())).remove(worldname.toLowerCase());
		//set some variables to null
		this.chunkProvider = null;
		this.chunkProviderServer = null;
		this.generator = null;
		this.j = null;
		this.h = null;
		this.players = null;
		this.tracker = null;
		this.worldMaps = null;
		this.worldProvider = null;
		this.random = null;
	}
	
	public void c() {};
	public void g() {};
	public IChunkProvider b() {return null;}

}
